<?php 
// AUTOLOAD CLASS
function autoloader ( $class ){
	$class_lower = strtolower($class);
	$pathes = array(
		INCLUDES_DIR . $class,
		INCLUDES_DIR . $class_lower,
		MODULES_DIR  . $class .'/'.$class,
		MODULES_DIR  . $class_lower. '/'.$class_lower
		);
	foreach ($pathes as $path) {
		$path .='.class.php';
		if(file_exists($path)){
			require_once $path; 
			break;
		}
	}
}
spl_autoload_register('autoloader');


function roundUpToAny ($n, $x = 5) {

	if ((intval($n) == $n) && (!is_float(intval($n) / $x))) {
		return intval($n);
	}
	else {
		return round(($n + $x / 2) / $x) * $x;
	}
}

function formatPhoneNumber($phoneNumber) {
	$phoneNumber = preg_replace('/[^0-9]/','',$phoneNumber);

	if(strlen($phoneNumber) > 10) {

		$countryCode = substr($phoneNumber, 0, strlen($phoneNumber)-9);
		$areaCode = substr($phoneNumber, -9, 3);
		$nextThree = substr($phoneNumber, -6, 3);
		$lastFour = substr($phoneNumber, -3, 4);

		$phoneNumber = '+'.$countryCode.' '.$areaCode.' '.$nextThree.' '.$lastFour;
	}
	else if(strlen($phoneNumber) == 10) {
		$areaCode = substr($phoneNumber, 0, 4);
		$nextThree = substr($phoneNumber, 4, 3);
		$lastFour = substr($phoneNumber, 7, 4);

		$phoneNumber = ''.$areaCode.' '.$nextThree.' '.$lastFour;
	}
	else if(strlen($phoneNumber) == 7) {
		$nextThree = substr($phoneNumber, 0, 3);
		$lastFour = substr($phoneNumber, 3, 4);

		$phoneNumber = $nextThree.'-'.$lastFour;
	}

	return $phoneNumber;
}
function formatTel($tel) {
    // vyhadzanie neplatnych znakov z cisla
	$tel = preg_replace('/[^0-9+]/','',$tel);

    // nahrada uvodnej "00" za "+"
	$tel = preg_replace('/^00/','+',$tel);

    // ak je +421 tak moze byt 0 (narodne cislo)
	$tel = preg_replace('/^\+421/', '0', $tel);

    // 09xx - standardne mobilne cisla
	$tel = preg_replace('/(^09[0-9]{2})([0-9]{3})/','$1 $2 ',$tel);

    // 0[3,4,5,6,7] - pevne linky (okrem BA)
	$tel = preg_replace('/(^0[34567][0-9]{1})([0-9]{3})/','$1 $2 ',$tel);

    // pevne linky BA
	$tel = preg_replace('/(^0[2])([0-9]{4})/','$1 $2 ',$tel);
	return $tel;
}

/**
 * RETURN ARRAY WITH PRE
 * @return </pre> => $array
 */
function pri($array){
	echo "<pre>";
	@print_r($array);
	echo "</pre>";
}

function get_layout($name){
	if(file_exists(LAYOUTS.$name)){
		require_once LAYOUTS.$name;
		echo "\r\n";
	}
}

/**
 * IF SLASH IS \ GIVE IT ON /
 * @param  string $action unique action name
 * @return string
 */
function slash($string){
	return str_replace('\\', '/', $string);
}

function get_folders($folder){
	$base_path = null;
	if(!is_dir($folder)){
		if(!is_dir(BASE_DIR .$folder)){
			return 'error';
		}
		else{
			$base_path = BASE_DIR;
		}
	}
	$files = (glob($base_path.$folder."/*"));
	if(isset($files) && is_array($files)){
		$dirs = array();
		foreach($files as $dir){
			if(is_dir($dir) and $dir != '.' and $dir != '..'){

				$dirs[] = basename($dir);
			}
		}
		pri($dirs);
		return $dirs;
	}
}
function valid_x_csrf(){	
	if($_SESSION['token'] == $_SERVER['HTTP_X_CSRF_TOKEN']){
		return true;
	}else{
		return false;
	}
}

function is_ajax(){	
	if(!empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest') {
		return true;
	}else{
		return false;
	}
}

function is_post(){
	return (isset($_POST) AND strtolower($_SERVER['REQUEST_METHOD']) == 'post') ? true : false;
}

function post($field){
	return (isset($_POST[$field]) ? $_POST[$field] : null);
}

function get($field){
	return (isset($_GET[$field]) ? $_GET[$field] : null);
}

/**
* RETURN DIRS/FILES FROM FOLDER
* @param $folder is dir when find
* @param both = return files and dirs
* @param files = return files
* @param dirs = return dirs
* @return array
*/
function get_files($folder, $what = 'both'){
	
	$files = glob(BASE_DIR."$folder/*");
	$exit = array();
	$end = array();
	$i= 0;
	foreach($files as $object => $file){
		$filePath = pathinfo($file, PATHINFO_DIRNAME);
		$path = explode($folder,$filePath);
		$count_sub_dirs = count(explode("/",slash($path[0])));

		$file_name = pathinfo($file, PATHINFO_BASENAME);

		$file_type = pathinfo($file, PATHINFO_EXTENSION);
		if(!empty($path[1])){
			$path = slash("/".$folder.$path[1]."/");
		}else{
			$path = slash("/".$folder."/");
		}
		if((is_dir($file) && $what ==='both') || (is_dir($file) && $what ==='dirs')){
			if($what ==='both'){
				$exit['dirs'][$file_name]['file_path'] = $path;
				$exit['dirs'][$file_name]['file_name'] = $file_name;
				$exit['dirs'][$file_name]['file_type'] = 'dir';
			}else{
				$exit[$file_name]['file_path'] = $path;
				$exit[$file_name]['file_name'] = $file_name;
				$exit[$file_name]['file_type'] = 'dir';
			}

		}else if((!is_dir($file) && $what === 'both') || (!is_dir($file) && $what === 'files')){
			if($what ==='both'){
				$exit['files'][$file_name]['file_path'] = $path;
				$exit['files'][$file_name]['file_name']= $file_name;
				$exit['files'][$file_name]['file_type'] = $file_type;
			}else{
				$exit['files'][$file_name]['file_path'] = $path;
				$exit['files'][$file_name]['file_name']= $file_name;
				$exit['files'][$file_name]['file_type'] = $file_type;
			}
			
		}
		
	}
	if($what ==='both'){
		if(isset($exit['dirs'])){
			$end['dirs'] = $exit['dirs'];
		}
		if(isset($exit['files'])){
			ksort($exit['files']);
			$end['files'] = $exit['files'];
		}
	}else{
		$end = $exit;
	}
	return $end;
}

/**
* CONVERT FILE SIZE FROM BYTES TO MAX 
* @param $bytes
* @return string
*/
function file_size_convert($bytes){
	$bytes = floatval($bytes);
	$arBytes = array(
		0 => array(
			"UNIT" => "TB",
			"VALUE" => pow(1024, 4)
			),
		1 => array(
			"UNIT" => "GB",
			"VALUE" => pow(1024, 3)
			),
		2 => array(
			"UNIT" => "MB",
			"VALUE" => pow(1024, 2)
			),
		3 => array(
			"UNIT" => "KB",
			"VALUE" => 1024
			),
		4 => array(
			"UNIT" => "B",
			"VALUE" => 1
			),
		);

	foreach($arBytes as $arItem){	

		if($bytes >= $arItem["VALUE"])
		{
			$result = $bytes / $arItem["VALUE"];
			$result = str_replace(".", "," , strval(round($result, 2)))." ".$arItem["UNIT"];
			break;
		}
	}
	return isset($result) ? $result : "0 B";
}

function convertBytes($value) {
	if (is_numeric($value)) {
		return $value;
	} else {
		$value_length = strlen($value);
		$qty = substr($value, 0, $value_length - 1);
		$unit = strtolower(substr( $value, $value_length - 1 ));
		switch ($unit) {
			case 'k':
			$qty *= 1024;
			break;
			case 'm':
			$qty *= 1048576;
			break;
			case 'g':
			$qty *= 1073741824;
			break;
		}
		return $qty;
	}
}
/**
* GET FOLDER SIZE
* @param $dir
* @return string
*/
function folder_size($dir){
	$size = 0;
	foreach (glob(rtrim($dir, '/').'/*', GLOB_NOSORT) as $each) {
		$size += is_file($each) ? filesize($each) : folder_size($each);
	}
	return $size;
}

function friendly_string($string,$separator = "-") {

	setlocale(LC_ALL, 'slovak');
	$string = iconv("utf-8", "us-ascii//TRANSLIT", $string);
	$string = lowercase($string);
	$string = trim($string, "$separator");
	$string = str_replace(' ', '-', $string);
	$string = preg_replace('/[^a-zA-Z0-9-_\/]/', '', $string);
	$string = preg_replace('~[^-a-z0-9_]+~', '', $string);

	return $string;
}


function controlExistFile($file){
	$actual_name = pathinfo($file,PATHINFO_FILENAME);
	$original_name = $actual_name;
	$extension = pathinfo($file, PATHINFO_EXTENSION);
	$i = 1;
	$name = $actual_name.'.'.$extension;
	while(file_exists(BASE_DIR."upload-files/".$actual_name.'.'.$extension))
	{           
		$actual_name = (string)$original_name."-".$i;
		$name = $actual_name.'.'.$extension;
		$i++;
	}
	
	return $name;
}

function redirect($url){
	if(!headers_sent()){
		header('Location: ' . preg_replace("/&amp;/", '&', $url));
	}else{
		echo '<script>window.location.href="' . $url . '";</script>';
	}
}


function lowercase($string){
	if(function_exists('mb_strtolower')){
		return mb_strtolower($string, 'UTF-8');
	}else{
		return strtolower($string);
	}
}


/**
* CONTROL UPLOAD FILE
* @param $path
* @return boolean
*/
function control_upload_file($path){
	if(isset($path) && !empty($path)){	
		if(file_exists(BASE_DIR.$path))
			return true;
		else
			return false;
	}
	return false;
}

/**
* CONTROL UPLOAD FILE
* @param $string
* @return string
*/
function remove_first_slash($string)
{
	return ltrim($string, '/');
}

function get_today_date(){
	return date('Y-m-d H:i:s');
}

function format_datetime($date, $new_format, $old_format = 'Y-m-d H:i:s'){
	$d = DateTime::createFromFormat($old_format, $date);
	return $d->format($new_format);
}

function trigger($place){
	global $module;
	$module->trigger($place);
}

function remove_double_slash($string)
{
	while( strpos($string, '//') !== false ) {
		$string = str_replace('//','/',$string);
	}

	return $string;
}